]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
Revert, doesn't work for every spec so is useless. Don't use rpmrc, simply use -...
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
1d7abbe3 1#!/bin/ksh
cd445739 2# -----------
cd445739 3# Exit codes:
2a5f078d 4# 0 - succesful
5# 1 - help displayed
6# 2 - no spec file name in cmdl parameters
7# 3 - spec file not stored in repo
8# 4 - some source, patch or icon files not stored in repo
9# 5 - package build failed
10# 6 - spec file with errors
11# 7 - wrong source in /etc/poldek.conf
12# 8 - Failed installing buildrequirements and subrequirements
13# 9 - Requested tag already exist
14# 10 - Refused to build fractional release
15# 100 - Unknown error (should not happen)
cd445739
AM
16
17# Notes (todo):
f7b91886 18# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 19# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 20# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 21
d43959a2
ER
22RCSID='$Id$'
23r=${RCSID#* * }
24rev=${r%% *}
25VERSION="v0.18/$rev"
26VERSIONSTRING="\
c9acaed9 27Build package utility from PLD Linux CVS repository
d43959a2
ER
28$VERSION (C) 1999-2007 Free Penguins".
29
d6a77ddb 30PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 31
cd445739 32COMMAND="build"
64ea5308 33TARGET=""
cd445739 34
bde1c404 35SPECFILE=""
d287305c 36BE_VERBOSE=""
4003ad8c 37QUIET=""
cd445739
AM
38CLEAN=""
39DEBUG=""
40NOURLS=""
41NOCVS=""
42NOCVSSPEC=""
43NODIST=""
47761337 44NOINIT=""
cd445739 45UPDATE=""
cd445739
AM
46ADD5=""
47NO5=""
48ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 49CVSROOT=""
cd445739
AM
50
51# It can be used i.e. in log file naming.
52# See LOGFILE example.
53DATE=`date +%Y-%m-%d_%H-%M-%S`
54
55# Example: LOGFILE='../log.$PACKAGE_NAME'
56# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
57# Yes, you can use variable name! Note _single_ quotes!
58LOGFILE=''
59
60LOGDIR=""
61LOGDIROK=""
62LOGDIRFAIL=""
63LASTLOG_FILE=""
64
65CHMOD="no"
66CHMOD_MODE="0444"
67RPMOPTS=""
d1c5a9a7 68RPMBUILDOPTS=""
cd445739
AM
69BCOND=""
70GROUP_BCONDS="no"
947025e5 71CVSIGNORE_DF="no"
d287305c 72
73PATCHES=""
74SOURCES=""
cd445739 75ICONS=""
d287305c 76PACKAGE_RELEASE=""
77PACKAGE_VERSION=""
78PACKAGE_NAME=""
cd445739
AM
79PROTOCOL="ftp"
80WGET_RETRIES=${MAX_WGET_RETRIES:-0}
81CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
82
83CVSTAG=""
84RES_FILE=""
39dcc7de 85CVS_FORCE=""
cd445739
AM
86
87CVS_SERVER="cvs.pld-linux.org"
88DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 89ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 90
36d03934 91DEF_NICE_LEVEL=19
86aafdbe 92SCHEDTOOL="auto"
cd445739
AM
93
94FAIL_IF_NO_SOURCES="yes"
95
18e5347d
ER
96# let get_files skip over files which are present to get those damn files fetched
97SKIP_EXISTING_FILES="no"
98
975d7b23 99TRY_UPGRADE=""
257af81b
ER
100# should the specfile be restored if upgrade failed?
101REVERT_BROKEN_UPGRADE="yes"
102
ab4a2b6e 103if [ -x /usr/bin/rpm-getdeps ]; then
ce40491a 104 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
ab4a2b6e 105else
ce40491a 106 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
ab4a2b6e
ER
107fi
108
cd445739
AM
109# Here we load saved user environment used to
110# predefine options set above, or passed to builder
111# in command line.
112# This one reads global system environment settings:
113if [ -f ~/etc/builderrc ]; then
114 . ~/etc/builderrc
115fi
116# And this one cascades settings using user personal
117# builder settings.
118# Example of ~/.builderrc:
119#
120#UPDATE_POLDEK_INDEXES="yes"
121#FETCH_BUILD_REQUIRES="yes"
122#REMOVE_BUILD_REQUIRES="force"
123#GROUP_BCONDS="yes"
124#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 125#TITLECHANGE=no
cd445739 126#
a83e5405 127SU_SUDO=""
cd445739
AM
128if [ -n "$HOME_ETC" ]; then
129 USER_CFG="$HOME_ETC/.builderrc"
130else
131 USER_CFG=~/.builderrc
132fi
133
134[ -f "$USER_CFG" ] && . "$USER_CFG"
135
86aafdbe
ER
136if [ "$SCHEDTOOL" = "auto" ]; then
137 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
138 SCHEDTOOL="schedtool -B -e"
139 else
140 SCHEDTOOL="no"
141 fi
142fi
143
ca2e6c31 144if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
145 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
146 GETURI2="$GETURI"
147 OUTFILEOPT="-O"
ca2e6c31 148elif [ -n "$USE_AXEL" ]; then
cede92b3 149 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
150 GETURI2="$GETURI"
151 OUTFILEOPT="-o"
ca2e6c31 152else
5700ee32
ER
153 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
154 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
155 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 156
7e365483
KK
157 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
158 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
159 OUTFILEOPT="-O"
2bc5451f 160fi
11468b23 161
11468b23
AM
162GETLOCAL="cp -a"
163
164if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
165 RPM="rpm"
166 RPMBUILD="rpm"
167else
168 RPM="rpm"
169 RPMBUILD="rpmbuild"
170fi
171
172POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 173POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 174
cd445739
AM
175run_poldek()
176{
177 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
178 if [ -n "$LOGFILE" ]; then
179 LOG=`eval echo $LOGFILE`
180 if [ -n "$LASTLOG_FILE" ]; then
181 echo "LASTLOG=$LOG" > $LASTLOG_FILE
182 fi
86aafdbe 183 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
184 return $exit_pldk
185 else
86aafdbe 186 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
187 return `cat ${RES_FILE}`
188 rm -rf ${RES_FILE}
189 fi
190}
191
cd445739
AM
192#---------------------------------------------
193# functions
da946cd6 194
5a491465 195usage()
196{
cd445739
AM
197 if [ -n "$DEBUG" ]; then set -xv; fi
198 echo "\
d43959a2 199Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|-ba|--build]
6594293d 200[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
4efa0b98 201[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
19dc5591 202[-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
203[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 204[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
cd445739 205[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
6594293d 206[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 207[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
6594293d 208<package>[.spec][:cvstag]
2a5f078d 209
cd445739
AM
210-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
211-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
212-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
213-D, --debug - enable builder script debugging mode,
214-debug - produce rpm debug package (same as --opts -debug)
d43959a2
ER
215-V, --version - output builder version string
216--short-version - output builder short version
cd445739
AM
217-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
218-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
219 from <package>.spec,
220-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
221 only package from <package>.spec,
c56807e0 222-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
223-bc - execute the %build phase of <package>.spec,
224-bi - execute the %install phase of <package>.spec
225-bl - execute the %files phase of <package>.spec
cd445739
AM
226-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
227 them into src.rpm,
6594293d 228--short-circuit - short-circuit build
cd445739
AM
229-B, --branch - add branch
230-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
231 SPECS and \$RPM_BUILD_ROOT),
39dcc7de 232-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 233-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
234 - setup \$CVSROOT,
235--define <macro> <value>
236 - define a macro <macro> with value <value>,
237--nodeps - rpm won't check any dependences
238-g, --get - get <package>.spec and all related files from CVS repo
239 or HTTP/FTP,
240-h, --help - this message,
241--http - use http instead of ftp,
242-l <logfile>, --logtofile <logfile>
243 - log all to file,
244-m, --mr-proper - only remove all files related to spec file and all work
245 resources,
246-nc, --no-cvs - don't download sources from CVS, if source URL is given,
247-ncs, --no-cvs-specs
248 - don't check specs in CVS
249-nd, --no-distfiles - don't download from distfiles
250-nm, --no-mirrors - don't download from mirror, if source URL is given,
251-nu, --no-urls - don't try to download from FTP/HTTP location,
252-ns, --no-srcs - don't download Sources
253-ns0, --no-source0 - don't download Source0
254-nn, --no-net - don't download anything from the net
b572253e 255--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
256-ske,
257--skip-existing-files - skip existing files in get_files
cd445739
AM
258--opts <rpm opts> - additional options for rpm
259-q, --quiet - be quiet,
260--date yyyy-mm-dd - build package using resources from specified CVS date,
261-r <cvstag>, --cvstag <cvstag>
262 - build package using resources from specified CVS tag,
5323fffd 263-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
264-R, --fetch-build-requires
265 - fetch what is BuildRequired,
266-RB, --remove-build-requires
267 - remove all you fetched with -R or --fetch-build-requires
268 remember, this option requires confirmation,
269-FRB, --force-remove-build-requires
270 - remove all you fetched with -R or --fetch-build-requires
271 remember, this option works without confirmation,
06541433
JR
272-sd, --source-distfiles - list sources available from distfiles (intended for offline
273 operations; does not work when Icon field is present
274 but icon file is absent),
275-sdp, --source-distfiles-paths - list sources available from distfiles -
276 paths relative to distfiles directory (intended for offline
277 operations; does not work when Icon field is present
278 but icon file is absent),
a7eefc54 279-sf, --source-files - list sources - bare filenames (intended for offline
280 operations; does not work when Icon field is present
3621e588 281 but icon file is absent),
a7eefc54 282-sp, --source-paths - list sources - filenames with full local paths (intended for
283 offline operations; does not work when Icon field is present
3621e588 284 but icon file is absent),
2dddf439
ER
285-su, --source-urls - list urls - urls to sources and patches
286 intended for copying urls with spec with lots of macros in urls
cd445739
AM
287-T <cvstag> , --tag <cvstag>
288 - add cvs tag <cvstag> for files,
289-Tvs, --tag-version-stable
094bd95b 290 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
291-Ts, --tag-stable
292 - add cvs tag STABLE for files,
cd445739 293-Tv, --tag-version
1691a37b 294 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
295-Tp, --tag-prefix <prefix>
296 - add <prefix> to NAME-VERSION-RELEASE tags,
297-tt, --test-tag <prefix>
298 - fail if tag is already present,
50321881
JK
299-ir, --integer-release-only
300 - allow only integer and snapshot releases
cd445739
AM
301-v, --verbose - be verbose,
302-u, --try-upgrade - check version, and try to upgrade package
303-un, --try-upgrade-with-float-version
304 - as above, but allow float version
deccc50e 305-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
306-Upi, --update-poldek-indexes
307 - refresh or make poldek package index files.
c890b916 308-np, --nopatch <patchnumber>
bed98670 309 - don't apply <patchnumber>
dfe2cb9a
MK
310--show-bconds - show available conditional builds, which can be used
311 - with --with and/or --without switches.
9b78be50
ER
312--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
313 ./repackage.sh script. in other words, the output is
314 parseable by scripts.
cd445739
AM
315--with/--without <feature>
316 - conditional build package depending on %_with_<feature>/
317 %_without_<feature> macro switch. You may now use
318 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
319 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 320--target <platform>, --target=<platform>
3621e588
ER
321 - build for platform <platform>.
322--init-rpm-dir - initialize ~/rpm directory structure
5a491465 323"
324}
325
c890b916 326update_shell_title() {
a0d6396b 327 [ -t 1 ] || return
0b65d15e
ER
328 local len=${COLUMNS:-80}
329 local msg=$(echo "$*" | cut -c-$len)
330
e225de91
ER
331 if [ -n "$BE_VERBOSE" ]; then
332 echo >&2 "$(date +%s.%N) $*"
333 fi
334
982e358c 335 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
336 local pkg
337 if [ -n "$PACKAGE_NAME" ]; then
338 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
339 else
340 pkg=${SPECFILE}
341 fi
342
343 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
10c1e115 344 msg="$(echo $msg | tr -d '\n\r')"
982e358c
MP
345 case "$TERM" in
346 cygwin|xterm*)
347 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
348 ;;
349 screen*)
350 echo >&2 -ne "\033]0;$msg\007"
351 ;;
352 esac
353 fi
c890b916
ER
354}
355
7e40520f
ER
356# set TARGET from BuildArch: from SPECFILE
357set_spec_target() {
ce40491a
ER
358 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
359 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
360 if [ "$tmp" ]; then
f9109a96 361 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
362 TARGET="$tmp"
363 case "$RPMBUILD" in
364 "rpmbuild")
f9109a96 365 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 366 "rpm")
ce40491a 367 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 368 esac
ce40491a
ER
369 fi
370 fi
7e40520f
ER
371}
372
ace3fd80
ER
373# runs rpm with minimal macroset
374minirpm() {
fa4bf1df 375 # we reset macros not to contain macros.build as all the %() macros are
559d511f 376 # executed here, while none of them are actually needed.
559d511f 377 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
13c3c336 378 safe_macrofiles=$(rpm --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
ace3fd80
ER
379
380 # TODO: move these to /usr/lib/rpm/macros
36433112 381 cat > .builder-rpmmacros <<'EOF'
f78a0bb7 382%alt_kernel %{nil}
383%_alt_kernel %{nil}
fb198857
ER
384%requires_releq_kernel_up %{nil}
385%requires_releq_kernel_smp %{nil}
6b8134e3 386%requires_releq() %{nil}
bb01dee9 387%pyrequires_eq() %{nil}
559d511f 388%requires_eq() %{nil}
c13be3d1 389%requires_eq_to() %{nil}
fb198857
ER
390%releq_kernel_up ERROR
391%releq_kernel_smp ERROR
74d9fd14 392%kgcc_package ERROR
237bd3f1 393%_fontsdir ERROR
7141278d 394%ruby_version ERROR
395%ruby_ver_requires_eq() %{nil}
396%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 397%__php_api_requires() %{nil}
7141278d 398%php_major_version ERROR
399%php_api_version ERROR
400%py_ver ERROR
41035426
ER
401%perl_vendorarch ERROR
402%perl_vendorlib ERROR
703ae20b
ER
403# damn. need it here! - copied from /usr/lib/rpm/macros.build
404%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
405%patchset_source(f:b:) %(
406 base=%{-b*}%{!-b*:10000};
407 start=$(expr $base + %1);
408 end=$(expr $base + %{?2}%{!?2:%{1}});
409 # we need to call seq twice as it doesn't allow two formats
410 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
411 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
412 paste %{tmpdir}/__ps{1,2};
413 rm -f %{tmpdir}/__ps{1,2};
414) \
415%{nil}
fb198857 416EOF
3d12d055
JR
417 if [ "$NOINIT" = "yes" ] ; then
418 cat >> .builder-rpmmacros <<'EOF'
419%_specdir ./
420%_sourcedir ./
421EOF
c039643c 422 fi
13c3c336 423 eval $RPMBUILD --macros "$safe_macrofiles:.builder-rpmmacros" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $* 2>&1
ace3fd80
ER
424}
425
426cache_rpm_dump() {
427 if [ -n "$DEBUG" ]; then
428 set -x
429 set -v
430 fi
431
432 update_shell_title "cache_rpm_dump"
433 local rpm_dump
434 rpm_dump=`
435 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
436 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
437 case "$RPMBUILD" in
438 rpm)
439 ARGS='-bp'
440 ;;
441 rpmbuild)
442 ARGS='--nodigest --nosignature --nobuild'
443 ;;
444 esac
445 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
237bd3f1 446 `
fb198857 447 if [ $? -gt 0 ]; then
237bd3f1
ER
448 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
449 echo "$error" >&2
518ff1fb 450 Exit_error err_build_fail
fb198857 451 fi
d05e8080
ER
452
453 # make small dump cache
454 rpm_dump_cache=`echo "$rpm_dump" | awk '
4e8c3089
ER
455 $2 ~ /^SOURCEURL/ {print}
456 $2 ~ /^PATCHURL/ {print}
457 $2 ~ /^nosource/ {print}
458 $2 ~ /^PACKAGE_/ {print}
d05e8080
ER
459 '`
460
13974367 461 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
462}
463
ace3fd80 464rpm_dump() {
cd445739 465 if [ -z "$rpm_dump_cache" ] ; then
d7b4d36e 466 echo "internal error: cache_rpm_dump not called! (missing %prep?)" 1>&2
cd445739
AM
467 fi
468 echo "$rpm_dump_cache"
469}
470
d05e8080
ER
471get_icons()
472{
473 update_shell_title "get icons"
474 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
475 if [ -z "$ICONS" ]; then
476 return
477 fi
478
975d7b23 479 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
480}
481
59398507 482parse_spec()
483{
af4d5315 484 update_shell_title "parsing specfile"
cd445739 485 if [ -n "$DEBUG" ]; then
518ff1fb
ER
486 set -x
487 set -v
cd445739 488 fi
b2975fc3 489
d05e8080 490 # icons are needed for successful spec parse
518ff1fb 491 get_icons
d05e8080 492
cd445739 493 cd $SPECS_DIR
cd445739 494 cache_rpm_dump
00fcec7e 495
cd445739
AM
496 if [ "$NOSRCS" != "yes" ]; then
497 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
498 fi
7cb24972 499
cd445739
AM
500 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
501 FAIL_IF_NO_SOURCES="no"
502 fi
503
504 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
505 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
dfe2b2d9
ER
506 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
507 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
508 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
78eab2a1 509
cd445739
AM
510 if [ -n "$BE_VERBOSE" ]; then
511 echo "- Sources : `nourl $SOURCES`"
512 if [ -n "$PATCHES" ]; then
513 echo "- Patches : `nourl $PATCHES`"
514 else
515 echo "- Patches : *no patches needed*"
516 fi
517 if [ -n "$ICONS" ]; then
518 echo "- Icon : `nourl $ICONS`"
519 else
520 echo "- Icon : *no package icon*"
521 fi
522 echo "- Name : $PACKAGE_NAME"
523 echo "- Version : $PACKAGE_VERSION"
524 echo "- Release : $PACKAGE_RELEASE"
525 fi
13974367
ER
526
527 update_shell_title "parse_spec: OK!"
cd445739
AM
528}
529
530Exit_error()
531{
532 if [ -n "$DEBUG" ]; then
518ff1fb
ER
533 set -x
534 set -v
cd445739
AM
535 fi
536
537 cd "$__PWD"
538
539 case "$1" in
540 "err_no_spec_in_cmdl" )
541 remove_build_requires
518ff1fb 542 echo "ERROR: spec file name not specified."
cd445739 543 exit 2 ;;
a08d92fc
ER
544 "err_invalid_cmdline" )
545 echo "ERROR: invalid command line arg ($2)."
546 exit 2 ;;
cd445739
AM
547 "err_no_spec_in_repo" )
548 remove_build_requires
518ff1fb 549 echo "Error: spec file not stored in CVS repo."
cd445739
AM
550 exit 3 ;;
551 "err_no_source_in_repo" )
552 remove_build_requires
518ff1fb 553 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739
AM
554 exit 4 ;;
555 "err_build_fail" )
556 remove_build_requires
518ff1fb 557 echo "Error: package build failed. (${2:-no more info})"
cd445739 558 exit 5 ;;
78eab2a1
AM
559 "err_no_package_data" )
560 remove_build_requires
561 echo "Error: couldn't get out package name/version/release from spec file."
562 exit 6 ;;
ce40491a 563 "err_tag_exists" )
50321881 564 remove_build_requires
518ff1fb 565 echo "Tag ${2} already exists (spec release: ${3})."
50321881 566 exit 9 ;;
ce40491a 567 "err_fract_rel" )
50321881 568 remove_build_requires
518ff1fb 569 echo "Release ${2} not integer and not a snapshot."
50321881 570 exit 10 ;;
fb96e0b5
AM
571 "err_branch_exists" )
572 remove_build_requires
518ff1fb 573 echo "Tree branch already exists (${2})."
fb96e0b5 574 exit 11 ;;
cfc497c0
ER
575 "err_acl_deny" )
576 remove_build_requires
577 echo "Error: conditions reject building this spec (${2})."
578 exit 12 ;;
cd445739 579 esac
73848362
ER
580 echo "Unknown error."
581 exit 100
cd445739
AM
582}
583
584init_builder()
585{
586 if [ -n "$DEBUG" ]; then
518ff1fb
ER
587 set -x
588 set -v
0dd6320d 589 fi
cd445739 590
4aeb9973 591 if [ "$NOINIT" != "yes" ] ; then
29e90b02
JR
592 SOURCE_DIR="`eval $RPM $RPMOPTS --eval '%{_sourcedir}'`"
593 SPECS_DIR="`eval $RPM $RPMOPTS --eval '%{_specdir}'`"
594 else
595 SOURCE_DIR="."
596 SPECS_DIR="."
597 fi
cd445739
AM
598
599 __PWD="`pwd`"
00fcec7e 600}
601
d6a77ddb 602get_spec()
1471f6d6 603{
c890b916 604
2e5be021 605 update_shell_title "get_spec"
c890b916 606
cd445739 607 if [ -n "$DEBUG" ]; then
518ff1fb
ER
608 set -x
609 set -v
cd445739
AM
610 fi
611
612 cd "$SPECS_DIR"
049ab214 613 if [ ! -f "$SPECFILE" ]; then
518ff1fb 614 SPECFILE="`basename $SPECFILE .spec`.spec"
cd445739
AM
615 fi
616 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 617
049ab214
ER
618 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
619 echo "Warning: No CVS access defined - using local .spec file"
620 NOCVSSPEC="yes"
cd445739
AM
621 fi
622
049ab214 623 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 624 fi
049ab214 625
cd445739 626 if [ ! -f "$SPECFILE" ]; then
518ff1fb 627 Exit_error err_no_spec_in_repo
cd445739
AM
628 fi
629
630 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
631 chmod $CHMOD_MODE $SPECFILE
632 fi
633 unset OPTIONS
a7eefc54 634 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f 635
ce40491a 636 set_spec_target
cd445739
AM
637}
638
639find_mirror()
640{
641 cd "$SPECS_DIR"
782518da 642 local url="$1"
cd445739
AM
643 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
644 cvs update mirrors >&2
645 fi
646
647 IFS="|"
782518da
ER
648 local origin mirror name rest ol prefix
649 while read origin mirror name rest; do
650 # skip comments and empty lines
651 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
652 continue
653 fi
cd445739
AM
654 ol=`echo -n "$origin"|wc -c`
655 prefix="`echo -n "$url" | head -c $ol`"
656 if [ "$prefix" = "$origin" ] ; then
782518da 657 suffix="`echo "$url"|cut -b $((ol+1))-`"
cd445739
AM
658 echo -n "$mirror$suffix"
659 return 0
660 fi
661 done < mirrors
662 echo "$url"
663}
664
e7e0d4ec 665# Warning: unpredictable results if same URL used twice
cd445739
AM
666src_no ()
667{
668 cd $SPECS_DIR
669 rpm_dump | \
670 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
671 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
672 head -n 1 | xargs
1471f6d6 673}
674
e7e0d4ec 675src_md5()
8ba5cdda 676{
e7e0d4ec 677 [ "$NO5" = "yes" ] && return
cd445739
AM
678 no=$(src_no "$1")
679 [ -z "$no" ] && return
680 cd $SPECS_DIR
e7e0d4ec
ER
681 local md5
682
683 if [ -f additional-md5sums ]; then
684 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
685 if [ -z "$spec_rev" ]; then
686 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
687 fi
688 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
689 md5=$(grep -s -v '^#' additional-md5sums | \
690 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
691 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
692 grep -E '^[0-9a-f]{32}$')
693
694 if [ "$md5" ]; then
695 if [ $(echo "$md5" | wc -l) != 1 ] ; then
696 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
697 fi
698 echo "$md5" | tail -n 1
699 return
700 fi
cd445739 701 fi
e7e0d4ec
ER
702
703 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
704 if [ -n "$source_md5" ]; then
705 echo $source_md5
cd445739 706 else
e7e0d4ec
ER
707 # we have empty SourceX-md5, but it is still possible
708 # that we have NoSourceX-md5 AND NoSource: X
709 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
03db3356 710 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
e7e0d4ec 711 echo $nosource_md5
cd445739 712 fi
cd445739
AM
713 fi
714}
715
06541433
JR
716distfiles_path ()
717{
718 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
719}
720
cd445739
AM
721distfiles_url ()
722{
06541433 723 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
724}
725
726distfiles_attic_url ()
727{
06541433 728 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
729}
730
731good_md5 ()
732{
733 md5=$(src_md5 "$1")
734 [ "$md5" = "" ] || \
735 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
736}
737
a4b50627
AF
738good_size ()
739{
ce40491a
ER
740 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
741 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
742}
743
947025e5 744cvsignore_df ()
745{
746 if [ "$CVSIGNORE_DF" != "yes" ]; then
747 return
748 fi
749 cvsignore=${SOURCE_DIR}/.cvsignore
750 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
751 echo "$1" >> $cvsignore
752 fi
753}
754
e7fa3b9f
ER
755cvsup()
756{
ce40491a
ER
757 update_shell_title "cvsup"
758 local OPTIONS="up "
759 if [ -n "$CVSROOT" ]; then
760 OPTIONS="-d $CVSROOT $OPTIONS"
761 fi
b1c6aace 762
ce40491a
ER
763 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
764 OPTIONS="$OPTIONS -A"
765 else
766 if [ -n "$CVSDATE" ]; then
767 OPTIONS="$OPTIONS -D $CVSDATE"
768 fi
769 if [ -n "$CVSTAG" ]; then
770 OPTIONS="$OPTIONS -r $CVSTAG"
771 fi
772 fi
e7fa3b9f 773
ce40491a
ER
774 local result=1
775 local retries_counter=0
776 if [ $# = 1 ]; then
777 update_shell_title "cvsup: $*"
778 else
779 update_shell_title "cvsup: $# files"
780 fi
781 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
782 retries_counter=$(( $retries_counter + 1 ))
783 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
784 result=$?
785 [ -n "$output" ] && echo "$output"
786 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
787 echo "Trying again [$*]... ($retries_counter)"
788 update_shell_title "cvsup: retry #$retries_counter"
789 sleep 2
790 continue
791 else
792 break
793 fi
794 done
795 update_shell_title "cvsup: done!"
796 return $result
e7fa3b9f
ER
797}
798
71f8e908
ER
799# returns true if "$1" is ftp, http or https protocol url
800is_url()
801{
802 case "$1" in
803 ftp://*|http://*|https://*)
804 return 0
805 ;;
806 esac
807 return 1
808}
809
ecba6ad5
ER
810update_md5()
811{
812 if [ $# -eq 0 ]; then
813 return
814 fi
815
816 update_shell_title "update md5"
817 if [ -n "$DEBUG" ]; then
518ff1fb
ER
818 set -x
819 set -v
ecba6ad5
ER
820 fi
821
822 cd "$SOURCE_DIR"
823
824 # pass 1: check files to be fetched
825 local todo
826 local need_files
827 for i in "$@"; do
828 local fp=$(nourl "$i")
829 local srcno=$(src_no "$i")
6392b5fd
ER
830 if [ -n "$ADD5" ]; then
831 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
832 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
833 else
834 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
ecba6ad5
ER
835 fi
836 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
837 need_files="$need_files $i"
838 fi
839 done
840
841 # pass 1a: get needed files
842 if [ "$need_files" ]; then
843 get_files $need_files
844 fi
845
846 # pass 2: proceed with md5 adding or updating
847 for i in "$@"; do
848 local fp=$(nourl "$i")
849 local srcno=$(src_no "$i")
71f8e908
ER
850 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
851 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
852 local tag="Source$srcno-md5"
853 if [[ "$md5" == *NoSource* ]]; then
854 tag="NoSource$srcno-md5"
855 fi
ecba6ad5 856 md5=$(md5sum "$fp" | cut -f1 -d' ')
4efa0b98 857 echo "Updating $tag ($md5: $fp)."
ecba6ad5 858 perl -i -ne '
71f8e908
ER
859 print unless /^\s*#\s*(No)?Source'$srcno'-md5\s*:/i;
860 print "# '$tag':\t'$md5'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5
ER
861 ' \
862 $SPECS_DIR/$SPECFILE
863 fi
864 done
865}
866
867check_md5()
868{
869 update_shell_title "check md5"
870
871 for i in "$@"; do
872 if good_md5 "$i" && good_size "$i"; then
873 continue
874 fi
875
876 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
877 echo "or -5 to update md5 sums, if you're sure files are correct."
878 Exit_error err_no_source_in_repo $i
879 done
880}
881
cd445739
AM
882get_files()
883{
7cb24972 884 update_shell_title "get_files"
cd445739
AM
885
886 if [ -n "$DEBUG" ]; then
518ff1fb
ER
887 set -x
888 set -v
cd445739
AM
889 fi
890
f09c0772 891 if [ $# -gt 0 ]; then
cd445739
AM
892 cd "$SOURCE_DIR"
893
b1c6aace 894 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 895 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
896 NOCVS="yes"
897 fi
898
f2e42a41 899 local nc=0
e7fa3b9f 900 local get_files_cvs=""
3815b69a 901 for i in "$@"; do
f2e42a41 902 nc=$((nc + 1))
dcebdffb 903 local cvsup=0
3815b69a 904 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 905 update_shell_title "$i"
f09c0772 906 local fp=`nourl "$i"`
ecba6ad5 907 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 908 continue
18e5347d 909 fi
ecba6ad5 910
cd445739 911 FROM_DISTFILES=0
e7e0d4ec 912 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
913
914 # we know if source/patch is present in cvs/distfiles
915 # - has md5 (in distfiles)
916 # - in cvs... ideas?
917
918 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 919 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
920 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
921 echo "Warning: no URL given for $i"
922 fi
923
e7e0d4ec 924 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 925 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 926 echo "$fp having proper md5sum already exists"
cd445739
AM
927 continue
928 fi
4ea1c265 929 target="$fp"
28b34560
ER
930
931 # prefer mirror over distfiles if there's mirror
932 # TODO: build url list and then try each url from the list
933 if [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
934 url="$im"
935 else
936 url=$(distfiles_url "$i")
937 fi
938
cd445739
AM
939 url_attic=$(distfiles_attic_url "$i")
940 FROM_DISTFILES=1
ecba6ad5
ER
941 # is $url local file?
942 if [[ "$url" = [./]* ]]; then
18a52930 943 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
944 ${GETLOCAL} $url $target
945 else
946 if [ -z "$NOMIRRORS" ]; then
9e9f8920 947 url=$(find_mirror "$url")
cd445739 948 fi
9e9f8920
ER
949
950 local uri=${url}
951 # make shorter message for distfiles urls
952 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
953 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
954 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
955 uri="df: $uri"
956 fi
957 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 958 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 959 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 960 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 961 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
962 fi
963 fi
ecba6ad5
ER
964
965 # is it empty file?
966 if [ ! -s "$target" ]; then
cd445739
AM
967 rm -f "$target"
968 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 969 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
970 ${GETLOCAL} $url_attic $target
971 else
972 if [ -z "$NOMIRRORS" ]; then
973 url_attic="`find_mirror "$url_attic"`"
974 fi
18a52930 975 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 976 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 977 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 978 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 979 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
980 fi
981 fi
982 fi
ecba6ad5
ER
983
984 if [ -s "$target" ]; then
947025e5 985 cvsignore_df $target
986 else
cd445739
AM
987 rm -f "$target"
988 FROM_DISTFILES=0
989 fi
e7e0d4ec 990 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
991 if [ $# -gt 1 ]; then
992 get_files_cvs="$get_files_cvs $fp"
993 update_shell_title "$fp (will cvs up later)"
994 cvsup=1
995 else
996 cvsup $fp
997 fi
cd445739
AM
998 fi
999
f09c0772 1000 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
1001 if [ -z "$NOMIRRORS" ]; then
1002 im="`find_mirror "$i"`"
1003 else
1004 im="$i"
1005 fi
ce40491a 1006 update_shell_title "${GETURI%% *}: $im"
cd445739 1007 ${GETURI} "$im" || \
33da77c4 1008 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1009 update_shell_title "${GETURI2%% *}: $im"
cd445739 1010 ${GETURI2} "$im"
7e365483 1011 fi
cd445739
AM
1012 fi
1013
dcebdffb
ER
1014 if [ "$cvsup" = 1 ]; then
1015 continue
1016 fi
1017
cd445739 1018 fi
ecba6ad5
ER
1019
1020 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1021 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
518ff1fb 1022 Exit_error err_no_source_in_repo $i
cd445739 1023 fi
2a5f078d 1024
ecba6ad5 1025 # we check md5 here just only to refetch immediately
a4b50627 1026 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1027 :
1028 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1029 # wrong md5 from distfiles: remove the file and try again
cd445739 1030 # but only once ...
deccc50e 1031 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1032 FROM_DISTFILES=2
1033 rm -f $target
18a52930 1034 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1035 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1036 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1037 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1038 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1039 fi
ecba6ad5 1040 if [ ! -s "$target" ]; then
cd445739 1041 rm -f "$target"
18a52930 1042 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1043 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1044 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1045 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1046 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1047 fi
1048 fi
1049 test -s "$target" || rm -f "$target"
1050 fi
cd445739 1051 done
e7fa3b9f
ER
1052 SHELL_TITLE_PREFIX=""
1053
1054 if [ "$get_files_cvs" ]; then
ce40491a 1055 cvsup $get_files_cvs
e7fa3b9f 1056 fi
cd445739
AM
1057
1058 if [ "$CHMOD" = "yes" ]; then
3815b69a 1059 CHMOD_FILES="`nourl "$@"`"
cd445739
AM
1060 if [ -n "$CHMOD_FILES" ]; then
1061 chmod $CHMOD_MODE $CHMOD_FILES
1062 fi
1063 fi
cd445739
AM
1064 fi
1065}
1066
1067make_tagver() {
ce40491a 1068 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1069 set -x
1070 set -v
ce40491a 1071 fi
78eab2a1 1072
ce40491a
ER
1073 # Check whether first character of PACKAGE_NAME is legal for tag name
1074 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1075 TAG_PREFIX=tag_
1076 fi
d712cc12
ER
1077
1078 # NOTE: CVS tags may must not contain the characters `$,.:;@'
392187d9 1079 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE | tr '[.@]' '[_#]')
d712cc12 1080
ce40491a
ER
1081 # Remove #kernel.version_release from TAGVER because tagging sources
1082 # could occur with different kernel-headers than kernel-headers used at build time.
d712cc12
ER
1083 # besides, %{_kernel_ver_str} is not expanded.
1084
1085 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1#%{_kernel_ver_str}
1086 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1087
1088 TAGVER=${TAGVER%#*}
ce40491a 1089 echo -n "$TAGVER"
cd445739
AM
1090}
1091
1092tag_files()
1093{
1094 TAG_FILES="$@"
1095
1096 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1097 set -x
1098 set -v
cd445739
AM
1099 fi
1100
73ef63d8
ER
1101 echo "Version: $PACKAGE_VERSION"
1102 echo "Release: $PACKAGE_RELEASE"
cd445739 1103
a18a9761 1104 local TAGVER
73ef63d8 1105 if [ "$TAG_VERSION" = "yes" ]; then
a18a9761 1106 TAGVER=`make_tagver`
73ef63d8
ER
1107 echo "CVS tag: $TAGVER"
1108 fi
1109 if [ -n "$TAG" ]; then
1110 echo "CVS tag: $TAG"
1111 fi
cd445739 1112
39dcc7de 1113 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1114 if [ -n "$CVSROOT" ]; then
1115 OPTIONS="-d $CVSROOT $OPTIONS"
1116 fi
cd445739 1117
73ef63d8
ER
1118 cd "$SOURCE_DIR"
1119 local tag_files
1120 for i in $TAG_FILES; do
1121 # don't tag files stored on distfiles
1122 [ -n "`src_md5 $i`" ] && continue
1123 local fp=`nourl "$i"`
1124 if [ -f "$fp" ]; then
1125 tag_files="$tag_files $fp"
1126 else
1127 Exit_error err_no_source_in_repo $i
03db3356 1128 fi
73ef63d8 1129 done
03db3356 1130
73ef63d8 1131 if [ "$tag_files" ]; then
cd445739 1132 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8 1133 update_shell_title "tag sources: $TAGVER"
c7e6ee9b 1134 cvs $OPTIONS $TAGVER $tag_files || exit
cd445739
AM
1135 fi
1136 if [ -n "$TAG" ]; then
73ef63d8 1137 update_shell_title "tag sources: $TAG"
c7e6ee9b 1138 cvs $OPTIONS $TAG $tag_files || exit
cd445739 1139 fi
73ef63d8
ER
1140 fi
1141
1142 cd "$SPECS_DIR"
1143 if [ "$TAG_VERSION" = "yes" ]; then
1144 update_shell_title "tag spec: $TAGVER"
c7e6ee9b 1145 cvs $OPTIONS $TAGVER $SPECFILE || exit
73ef63d8
ER
1146 fi
1147 if [ -n "$TAG" ]; then
1148 update_shell_title "tag spec: $TAG"
c7e6ee9b 1149 cvs $OPTIONS $TAG $SPECFILE || exit
73ef63d8 1150 fi
cd445739
AM
1151}
1152
1153branch_files()
1154{
1155 TAG=$1
1156 echo "CVS branch tag: $TAG"
518ff1fb 1157 shift
cd445739
AM
1158
1159 TAG_FILES="$@"
1160
1161 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1162 set -x
1163 set -v
cd445739
AM
1164 fi
1165
78a5a506
ER
1166 local OPTIONS="tag $CVS_FORCE -b"
1167 if [ -n "$CVSROOT" ]; then
1168 OPTIONS="-d $CVSROOT $OPTIONS"
1169 fi
1170 cd "$SOURCE_DIR"
1171 local tag_files
1172 for i in $TAG_FILES; do
1173 local fp=`nourl "$i"`
1174 if [ -f "$fp" ]; then
1175 tag_files="$tag_files $fp"
1176 else
1177 Exit_error err_no_source_in_repo $i
c10fa4fa 1178 fi
78a5a506
ER
1179 done
1180 if [ "$tag_files" ]; then
c7e6ee9b 1181 cvs $OPTIONS $TAG $tag_files || exit
78a5a506 1182 fi
c10fa4fa 1183
78a5a506 1184 cd "$SPECS_DIR"
c7e6ee9b 1185 cvs $OPTIONS $TAG $SPECFILE || exit
cd445739
AM
1186}
1187
1188
3009b80d
ER
1189# this function should exit early if package can't be built for this arch
1190# this avoids unneccessary BR filling.
1191check_buildarch() {
1192 local out ret
13c3c336 1193 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
3009b80d
ER
1194 ret=$?
1195 if [ $ret -ne 0 ]; then
1196 echo >&2 "$out"
1197 exit $ret
1198 fi
1199}
1200
cd445739 1201
59398507 1202build_package()
1203{
2e5be021 1204 update_shell_title "build_package"
cd445739 1205 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1206 set -x
1207 set -v
cd445739 1208 fi
5a491465 1209
cd445739
AM
1210 cd "$SPECS_DIR"
1211
1212 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1213 update_shell_title "build_package: try_upgrade"
cd445739 1214 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 1215 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 1216 else
cc538c24 1217 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
1218 fi
1219
1220 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
1221
1222 if [ -n "$TNEWVER" ]; then
1223 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1224 echo "New version found, updating spec file to version " $TNEWVER
257af81b
ER
1225 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1226 cp -f $SPECFILE $SPECFILE.bak
1227 fi
cd445739
AM
1228 chmod +w $SPECFILE
1229 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1230 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
518ff1fb
ER
1231 parse_spec
1232 NODIST="yes" get_files $SOURCES $PATCHES
6392b5fd 1233 update_md5 $SOURCES
975d7b23 1234
cd445739
AM
1235 unset TOLDVER TNEWVER TNOTIFY
1236 fi
1237 fi
1238 cd "$SPECS_DIR"
2a5f078d 1239
cd445739
AM
1240 case "$COMMAND" in
1241 build )
1242 BUILD_SWITCH="-ba" ;;
1243 build-binary )
1244 BUILD_SWITCH="-bb" ;;
1245 build-source )
1246 BUILD_SWITCH="-bs --nodeps" ;;
1247 build-prep )
1248 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1249 build-build )
1250 BUILD_SWITCH="-bc" ;;
1251 build-install )
1252 BUILD_SWITCH="-bi" ;;
1253 build-list )
1254 BUILD_SWITCH="-bl" ;;
1255
cd445739 1256 esac
c890b916 1257
2e5be021 1258 update_shell_title "build_package: $COMMAND"
cd445739
AM
1259 if [ -n "$LOGFILE" ]; then
1260 LOG=`eval echo $LOGFILE`
1261 if [ -d "$LOG" ]; then
1262 echo "Log file $LOG is a directory."
1263 echo "Parse error in the spec?"
518ff1fb 1264 Exit_error err_build_fail
cd445739
AM
1265 fi
1266 if [ -n "$LASTLOG_FILE" ]; then
1267 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1268 fi
1269 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
86aafdbe 1270 (time eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1271 RETVAL=`cat $RES_FILE`
1272 rm $RES_FILE
1273 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1274 if [ "$RETVAL" -eq "0" ]; then
1275 mv $LOG $LOGDIROK
1276 else
1277 mv $LOG $LOGDIRFAIL
1278 fi
1279 fi
8ba5cdda 1280 else
86aafdbe 1281 eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1282 RETVAL=$?
8ba5cdda 1283 fi
cd445739
AM
1284 if [ "$RETVAL" -ne "0" ]; then
1285 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1286 echo "\n!!! Package with new version cannot be built automagically\n"
257af81b
ER
1287 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1288 mv -f $SPECFILE.bak $SPECFILE
1289 fi
cd445739 1290 fi
518ff1fb 1291 Exit_error err_build_fail
cd445739
AM
1292 fi
1293 unset BUILD_SWITCH
1294}
1295
1296nourl()
1297{
1298 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1299}
1300
cd445739
AM
1301install_required_packages()
1302{
1303 run_poldek -vi $1
1304 return $?
1305}
1306
fa4bf1df
ER
1307find_spec_bcond() {
1308 # taken from find-spec-bcond, but with just getting the list
1309 local SPEC="$1"
1310 # quick revert hint: '$RPMBUILD --bcond $SPEC'
1311 awk -F"\n" '
1312 /^%changelog/ { exit }
1313 /_with(out)?_[_a-zA-Z0-9]+/{
1314 match($0, /_with(out)?_[_a-zA-Z0-9]+/);
1315 print substr($0, RSTART, RLENGTH);
1316 }
1317 /^%bcond_with/{
1318 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1319 bcond = substr($0, RSTART +5 , RLENGTH -5);
1320 gsub(/[ \t]+/,"_",bcond);
1321 print bcond
1322 }' $SPEC | LC_ALL=C sort -u
1323}
1324
117d9861 1325process_bcondrc() {
301cbfd4
ER
1326 # expand bconds from ~/.bcondrc
1327 # The file structure is like gentoo's package.use:
1328 # ---
1329 # * -selinux
1330 # samba -mysql -pgsql
47a8df12 1331 # w32codec-installer license_agreement
301cbfd4
ER
1332 # php +mysqli
1333 # ---
fa4bf1df 1334 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1335 :
1336 else
1337 return
1338 fi
301cbfd4 1339
117d9861 1340 SN=${SPECFILE%%\.spec}
c8a3e2ac 1341
117d9861
ER
1342 local bcondrc=$HOME/.bcondrc
1343 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1344
117d9861 1345 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1346
117d9861
ER
1347 while read pkg flags; do
1348 # ignore comments
1349 [[ "$pkg" == \#* ]] && continue
1350
1351 # any package or current package?
1352 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1353 for flag in $flags; do
1354 local opt=${flag#[+-]}
1355
1356 # use only flags which are in this package.
1357 if [[ $bcond_avail = *${opt}* ]]; then
1358 if [[ $flag = -* ]]; then
1359 if [[ $BCOND != *--with?${opt}* ]]; then
1360 BCOND="$BCOND --without $opt"
1361 fi
1362 else
1363 if [[ $BCOND != *--without?${opt}* ]]; then
1364 BCOND="$BCOND --with $opt"
301cbfd4
ER
1365 fi
1366 fi
117d9861
ER
1367 fi
1368 done
1369 fi
1370 done < $bcondrc
1371 update_shell_title "parse ~/.bcondrc: DONE!"
1372}
1373
1374set_bconds_values()
1375{
1376 update_shell_title "set bcond values"
1377
1378 AVAIL_BCONDS_WITHOUT=""
1379 AVAIL_BCONDS_WITH=""
1380 if `grep -q ^%bcond ${SPECFILE}`; then
1381 BCOND_VERSION="NEW"
1382 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
1383 BCOND_VERSION="OLD"
1384 else
1385 return
301cbfd4
ER
1386 fi
1387
117d9861
ER
1388 local bcond_avail=$(find_spec_bcond $SPECFILE)
1389 process_bcondrc "$SPECFILE"
1390
fa4bf1df 1391 update_shell_title "parse bconds"
cd445739 1392 case "${BCOND_VERSION}" in
fa4bf1df 1393 NONE)
7e365483 1394 :
cd445739 1395 ;;
7e365483 1396 OLD)
cd445739 1397 echo "Warning: This spec has old style bconds. Fix it || die."
fa4bf1df 1398 for opt in `echo "$bcond_avail" | grep ^_without_`
cd445739 1399 do
fa4bf1df
ER
1400 AVAIL_BCOND_WITHOUT=${opt#_without_}
1401 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1402 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1403 else
1404 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1405 fi
1406 done
2a5f078d 1407
fa4bf1df 1408 for opt in `echo "$bcond_avail" | grep ^_with_`
cd445739 1409 do
fa4bf1df
ER
1410 AVAIL_BCOND_WITH=${opt#_with_}
1411 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1412 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1413 else
1414 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1415 fi
1416 done
1417 ;;
1418 NEW)
fa4bf1df
ER
1419 local cond_type="" # with || without
1420 for opt in $bcond_avail; do
cd445739
AM
1421 case "$opt" in
1422 _without)
1423 cond_type="without"
1424 ;;
1425 _with)
1426 cond_type="with"
1427 ;;
f8d24cee 1428 _without_*)
fa4bf1df
ER
1429 AVAIL_BCOND_WITHOUT=${opt#_without_}
1430 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
f8d24cee 1431 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1432 else
1433 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1434 fi
1435 ;;
1436 _with_*)
fa4bf1df
ER
1437 AVAIL_BCOND_WITH=${opt#_with_}
1438 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
f8d24cee 1439 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1440 else
1441 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1442 fi
1443 ;;
cd445739
AM
1444 *)
1445 case "$cond_type" in
1446 with)
1447 cond_type=''
1448 AVAIL_BCOND_WITH="$opt"
fa4bf1df 1449 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1450 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1451 else
1452 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1453 fi
7e365483 1454 ;;
cd445739
AM
1455 without)
1456 cond_type=''
1457 AVAIL_BCOND_WITHOUT="$opt"
fa4bf1df 1458 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1459 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1460 else
1461 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1462 fi
1463 ;;
1464 esac
1465 ;;
1466 esac
1467 done
1468 ;;
1469 esac
1470}
1471
1472run_sub_builder()
1473{
1474 package_name="${1}"
af6b168f 1475 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1476 #
1477